#clear workspace
rm(list = ls())
#set true to export png
DoPNG <- TRUE
#DoPNG <- FALSE

#needed packages
#if (!require("psych")) { #describe()
#if (!require("png")) {
#   install.packages("png", dependencies = TRUE)
#   library(png)
#   }

print("Reading data")
rawdata <- read.table("results-survey422516.csv",header=TRUE,sep=",")

if (DoPNG) png("Visits.png",width=600,height=500)
visits <- table(rawdata[6],exclude="")[order(c(4,2,3,1))]
barplot(round(visits/sum(visits)*100),main="How often did you visit LibreOffice's websites in the last year?")
if (DoPNG) dev.off()
rm(visits)

if (DoPNG) png("Reasons.png",width=900,height=500)
aData <- 1:8
nTotal = sum(rawdata[7] != "")
for(i in 1:8) aData[i] = round(sum(rawdata[i+6] == "Yes")/nTotal*100)
rnames = c("General information","Downloads","Extensions","Development","Donation","Documentation","Contribution","Legal")
barplot(aData, beside=TRUE, names.arg=rnames,main="What were you looking for?",sub="Multiple choice")
if (DoPNG) dev.off()

#if (DoPNG) png("Success.png",width=500,height=500)
#pie(table(rawdata[16],exclude="N/A"),main="Were you able to find what you were looking for?",col=c("darkred","darkgreen"))
#if (DoPNG) dev.off()
print("Success: ")
print(table(rawdata[16],exclude=""))

if (DoPNG) png("Method.png",width=600,height=600)
aData <- table(rawdata[17],exclude="")
aPlot <- barplot(aData,horiz=T,yaxt="n",space=1,width=1,main="How did you try to find the page you were looking for?")
aNames <- c("Browsed through several pages; took me a while","Other","Started at the landing page and used the site navigation","The right page is in my browser history","Used a search engine first")
text(0,aPlot+0.7,aNames,adj=0)
if (DoPNG) dev.off()

print("Usage: ")
print(table(rawdata[20],exclude=""))

print("Expertise: ")
print(table(rawdata[21],exclude=""))

if (DoPNG) png("TechSavvy.png",width=600,height=600)
aData <- table(rawdata[22],exclude="")
aOrder <- c(4,2,5,3,1)
aPlot <- barplot(aData[aOrder],horiz=T,yaxt="n",space=1,width=1,main="How tech-savvy would you assess yourself?")
aNames <- c("I'm a professional system administrator / developer","Friends ask me for help","Using the Internet I can help myself","I ask friends for help","Complete layman")
text(0,aPlot+0.7,aNames,adj=0)
if (DoPNG) dev.off()

print("Contribution: ")
print(table(rawdata[24],exclude=""))

if (DoPNG) png("ContribField.png",width=900,height=500)
aData <- 1:8
nTotal = sum(table(rawdata[25],exclude="N/A"))
for(i in 1:8) aData[i] = round(sum(rawdata[i+24] == "Yes")/nTotal*100)
aNames = c("Development","Localization","Quality Assurance","Infrastructure","User Support","Documentation","Marketing","User Experience")
barplot(aData, beside=TRUE, names.arg=aNames,main="In what areas did you contribute?",sub="Multiple choice")
if (DoPNG) dev.off()

#if (DoPNG) png("ContribReason.png",width=900,height=500)
aData <- 1:4
nTotal = sum(table(rawdata[34],exclude="N/A"))
for(i in 1:4) aData[i] = round(sum(rawdata[i+33] == "Yes")/nTotal*100)
#aNames = c("To learn new skills","To support LibreOffice s mission of providing free  open source software","To meet #new people in the LibreOffice community","Other")
#barplot(aData, beside=TRUE, names.arg=aNames,main="Why did you contribute to LibreOffice?",sub="Multiple choice")
#if (DoPNG) dev.off()
print("Reason:")
print(aData)

print("Cleaning up...");
rm(aPlot)
rm(aData)
rm(aNames)
rm(nTotal)
rm(aOrder)
